#SIGN can be 0 or 1

function(connectivityMATRIX,genes,SIGN=0,directory=NULL,fileNAME=NULL,saveFile=FALSE){
  
  if(is.null(directory)){
    dir.create('Results')
    directory <- 'Results'
  }
  
  if(is.null(fileNAME)){
    fileNAME <- 'GRNprediction.txt'
  }
  
  numGENES <- length(genes)
  interactions <- as.vector(connectivityMATRIX)
  
  edges <- vector(length = length(interactions))
  if(SIGN==1){
    edges[which(interactions<0)] <- "repression"
    edges[which(interactions>0)] <- "activation"
    edges[which(interactions==0)] <- "no regulation"
  }else{
    edges[which(interactions==0)] <- "no regulation"
    edges[which(interactions!=0)] <- "activation/repression"
  }
  
  interactions <- abs(interactions)
  
  sourceGENES <- as.vector(replicate(numGENES,genes))
  targetGENES <- as.vector(t(replicate(numGENES,genes)))
  
  df <- data.frame(sourceGENES,targetGENES,interactions,edges)
  colnames(df) <- c('SourceGENES','TargetGENES','Interaction','Edges')
  df <- df[order(-df$Interaction),]
  if(saveFile) write.csv(df,file = file.path(directory,fileNAME),row.names = FALSE,quote = FALSE)
  
  return(df)
}